From 607a610ac295348aabddab227396c8bac98e1df7 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Fri, 6 Dec 2019 10:29:23 +0100
Subject: [PATCH] fonts: add Open Sans Condensed (#3825138251)

---
 README                                          |   7 +++++++
 .../OpenSans-CondBold-webfont.woff              | Bin 0 -> 21072 bytes
 .../OpenSans-CondLight-webfont.woff             | Bin 0 -> 20156 bytes
 .../OpenSans-CondLightItalic-webfont.woff       | Bin 0 -> 21068 bytes
 static/includes/_font-opensans-condensed.scss   |  12 ++++++++++++
 5 files changed, 19 insertions(+)
 create mode 100644 static/fonts/OpenSansCondensed/OpenSans-CondBold-webfont.woff
 create mode 100644 static/fonts/OpenSansCondensed/OpenSans-CondLight-webfont.woff
 create mode 100644 static/fonts/OpenSansCondensed/OpenSans-CondLightItalic-webfont.woff
 create mode 100644 static/includes/_font-opensans-condensed.scss

diff --git a/README b/README
index 79fc422f..81b13ee9 100644
--- a/README
+++ b/README
@@ -242,6 +242,13 @@ copyright notices:
   #
   # https://www.fontsquirrel.com/license/muli
 
+* Open Sans Condensed
+  # Copyright Ascender Corp.
+  #
+  # Apache License
+  #
+  # https://www.fontsquirrel.com/license/open-sans-condensed
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/OpenSansCondensed/OpenSans-CondBold-webfont.woff b/static/fonts/OpenSansCondensed/OpenSans-CondBold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..31e71c665daf4d06300aecf546b409bd0766af97
GIT binary patch
diff --git a/static/fonts/OpenSansCondensed/OpenSans-CondLight-webfont.woff b/static/fonts/OpenSansCondensed/OpenSans-CondLight-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..788d536cf5cc12d9e40bbf916a7ffd835c3918b8
GIT binary patch
diff --git a/static/fonts/OpenSansCondensed/OpenSans-CondLightItalic-webfont.woff b/static/fonts/OpenSansCondensed/OpenSans-CondLightItalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..13da31917d2578c285a54763d5ee7ff8c8e8850f
GIT binary patch
diff --git a/static/includes/_font-opensans-condensed.scss b/static/includes/_font-opensans-condensed.scss
new file mode 100644
index 00000000..40bf05b1
--- /dev/null
+++ b/static/includes/_font-opensans-condensed.scss
@@ -0,0 +1,12 @@
+@mixin opensans-condensed-font($type, $weight, $style: normal) {
+    @font-face {
+        font-family: 'Open Sans Condensed';
+        src: url('/static/fonts/OpenSansCondensed/OpenSans-Cond#{$type}-webfont.woff') format('woff');
+        font-weight: $weight;
+        font-style: $style;
+    }
+}
+
+@include opensans-condensed-font('Light', 300);
+@include opensans-condensed-font('LightItalic', 300, 'italic');
+@include opensans-condensed-font('Bold', 700);
-- 
2.24.0